/*
    ds-mod3.txt 
*/
#include <stdio.h>
#include <ctype.h>
#include <math.h>
#include <string.h>
#include <stdlib.h>
/* #include <windows.h> */

/*
    PQ IIR tB^[
*/
#include "p12o.h"

/*
    FFT ɂ http://momonga.t.u-tokyo.ac.jp/%7Eooura/fftman/index.html
    ŏЉĂ fft4g.c gp
*/
void cdft(int, int, double *, int *, double *);

#define NMAXSQRT  256  /* up to 65536 point */
#define NMAX      (2*NMAXSQRT*NMAXSQRT)

int n, ip[NMAXSQRT + 2];
double a[NMAX + 1 + 1], w[NMAX * 5 / 4];

/*
    Ot\ɂ gnuplot gp
*/
const char* pname = "\"C:/Program Files/gnuplot/bin/pgnuplot.exe\"";

/* "gnuplot" R}h */
const char* gcm[] = {
    "set size 0.68, 0.82",
    "set key outside below",
    "set grid",
    "set style data line",
    "set xlabel 'freq (Hz)'",
    "set ylabel 'amplitude (dB)'",
    "set logscale x",
//  "plot 0, 'plot1.dat'",
    0
};

/*
    O[oϐ
*/
int nswp = 1;        /* simulation sweep  (.step param ... ) */
int nv = 0, np = 0;  /* ϐ̐Af[^|Cg */
double tstep;        /* ^CXebv */
p2o p2oLP[4];        /* IIR tB^[p[^[ */
int skip = 4096;     /* 擪͎̂Ă邪AtB^[͓삳 */
int nj = 1;          /* nj Ԃ̕ϐg */
char buf[512];

/*
    t@CǂŃf[^ a[] ɒu
*/
int p3(FILE* ifd)
{
    /* nv, np 擾 */
    while (fgets(buf, sizeof(buf), ifd) != NULL) {
        if (strstr(buf, "No. Variables:") != NULL) {
            if (sscanf(strchr(buf, ':') + 1, "%d", &nv) != 1)
                return -1;
        } else if (strstr(buf, "No. Points:") != NULL) {
            if (sscanf(strchr(buf, ':') + 1, "%d", &np) != 1)
                return -1;
            if (np - 1 > NMAX) {
                printf("np too large, %d\n", np);
                return -1;
            }
            // printf("nv %d, np/nswp %d\n", nv, np/nswp);
            break;
        }
    }

    /* ϐ "Values" 擾 */
    while (fgets(buf, sizeof(buf), ifd) != NULL) {
        if (strstr(buf, "Variables:") != NULL)
            break;
        // printf("0 %s", buf);
    }
    while (fgets(buf, sizeof(buf), ifd) != NULL) {
        if (strstr(buf, "Values:") != NULL)
            break;
        printf("%s", buf);
    }
    // printf("%s", buf);
    return 0;
}

#define FC 100

int p2(FILE* ifd, int ns)
{
    int i, j, iv;
    double t, fv, ac0, ac1, ac2;

    p2oLP_init(&p2oLP[0], 100*1024, 1.164 * FC, 0.51);  /* tB^[ */
    p2oLP_init(&p2oLP[1], 100*1024, 1.381 * FC, 0.56);
    p2oLP_init(&p2oLP[2], 100*1024, 1.963 * FC, 0.71);
    p2oLP_init(&p2oLP[3], 100*1024, 2.992 * FC, 1.23);

    /* f[^擾AtB^[sAʂ a[] ɒu */
    double* p = a;
    for (i = 0; i < np - 1; i += 1)
        for (j = 0; j < nv; j += 1) {
            if (fgets(buf, sizeof(buf), ifd) == NULL) {
                printf("Null data line\n");
                return -1;
            }
            // printf("%d:%d %s", i, j, buf);
            if (j == 0) {
                if (sscanf(buf, "%d\t%lf", &iv, &t) != 2) {
                    printf("Numeric error\n");
                    return -1;
                }
                if (ns == 0 && i == 1) {
                    tstep = t;
                    // printf("tstep %g\n", tstep);
                }
            } else {
                if (sscanf(buf, "\t%lf", &fv) != 1) {
                    printf("Numeric error\n");
                    return -1;
                }
                if (j == nj) {  /*  nj Ԃ̃f[^ */
                    fv = (fv >= 0) ? 2 : -2;
                    ac0 = p2oLPF(&p2oLP[0], fv);
                    ac1 = p2oLPF(&p2oLP[1], ac0);
                    ac2 = p2oLPF(&p2oLP[2], ac1);
                    fv  = p2oLPF(&p2oLP[3], ac2);
                    if (i >= skip)  {
                        *p++ = fv;
                        *p++ = 0;
                        // if (i < 20) printf("%g %g\n", t, fv);
                    }
                }
            }
        }
    return 0;
}

/*
    a[]  FFT Čʂt@Cɏ
*/
int p0(FILE* ifd)
{
    int ns, i;
    double* p;

    if (p3(ifd) < 0)  /* wb_[̏ */
        return -1;
    printf("nswp %d, np/nswp %d, nv %d\n", nswp, np/nswp, nv);
    printf("skip %d, var# %d\n", skip, nj);
    np /= nswp;
    n = np - skip - 1;

    for (ns = 0; ns < nswp; ns += 1) {
        sprintf(buf, "plot%d.dat", ns + 1);
        FILE* ofd = fopen(buf, "w");
        if (!ofd) {
            printf("fopen(\"w\") fail\n");
            return -1;
        }
        if (p2(ifd, ns) < 0)  /* f[^̏ */
            return -1;
        if (ns == 0)
            printf("%d point FFT, tstep %g, n*tstep %gms\n", n, tstep, 1e3 * n * tstep);
        ip[0] = 0;
        cdft(2*n, 1, a, ip, w);    /* FFT */
        p = a;
        for (i = 0; i < n / 32; i += 1, p += 2) {  /*  n / 32 */
            if (i == 0)
                continue;
            fprintf(ofd, "%g %g\n",
              (double)i / (n * tstep),
              20*log10(
                sqrt(pow(*p, 2) + pow(*(p+1), 2))
              / n) + 3.200867);  /* atan2(*(p+1), *p) */
        }
        fclose(ofd);
    }
    return 0;
}

/*
    f[^̗pӂł̂ pgnuplot N
*/
int p1()
{
    FILE* pfd = popen(pname, "w");
    if (!pfd) {
        printf("popen %s fail", pname);
        return -1;
    }
    _sleep(1000);
    int i;
    char* s = buf;
    for (i = 0; gcm[i]; i += 1)
        fprintf(pfd, "%s\n", gcm[i]);
    for (i = 1; i <= nswp; i += 1)
        s += sprintf(s, "%s, 'plot%d.dat'", (i == 1) ? "plot 0" : "", i);
    sprintf(s, "\n");
    fputs(buf, pfd);
    fflush(pfd);
    fflush(stdout);
    getc(stdin);
    fputs("exit\n", pfd);
    pclose(pfd);
    return 0;
}

int main(int argc, char *argv[])
{
    FILE* ifd = fopen("ltsputil3.log", "r");
    if (!ifd) {
        printf("fopen(\".log\") fail\n");
        return 255;
    }
    while (fgets(buf, sizeof(buf), ifd) != NULL) {
        char* s;
        if ((s = strstr(buf, "sweep")) != NULL) {
            if ((s = strchr(s, ':')) != NULL) {
                if (sscanf(s + 1, "%d", &nswp) != 1) {  /* nswp 擾 */
                    printf("No of sweeps unknown.\n");
                    return 255;
                }
            }
        }
    }
    fclose(ifd);

    ifd = fopen("ds-mod3.txt", "r");
    if (!ifd) {
        printf("fopen(\".txt\") fail\n");
        return 255;
    }
    int r = p0(ifd);
    fclose(ifd);
    if (r)
        return 255;
    r = p1();
    return r ? 255 : 0;
}
